import math
from random import randint

#modifier le nom de votre fichier d'exportation et le chemin de destination
f=open(r'C:\Python34\montagne3D.svg','w')

ech=5 #ici on calcule sur un carré de 2puissance 5 points, soit 32 sur 32 points
nbpt=2**ech+1

delta=nbpt-1
y=[[0]*nbpt for i in range(nbpt)]
fact=2#0.5
min=0
max=0

offy=4

def trace(delta):

        #execute le programme qui s'appelle a nouveau
    for j in range (0,nbpt,2*delta):
        for i in range (delta,nbpt-delta,2*delta):
            y[i][j]=(y[i-delta][j]+y[i+delta][j])/2
    for j in range (0,nbpt,2*delta):
        for i in range (delta,nbpt-delta,2*delta):
            y[j][i]=(y[j][i-delta]+y[j][i+delta])/2

    for j in range (delta,nbpt-delta,2*delta):
        for i in range (delta,nbpt-delta,2*delta):
            y[j][i]=(y[j-delta][i-delta]+y[j-delta][i+delta]+y[j+delta][i-delta]+y[j+delta][i+delta])/4
            
    for j in range (0,nbpt,delta):
        for i in range (0,nbpt,delta):
            y[i][j]+=fact*(randint(0,delta)-delta/2)
            #print(i,j,delta)
    if delta==1:
        return
    else:        
        trace(int(delta/2))
        trace(int(delta/2))

#détermine les valeur hexa des couleurs (niveau de gris ici)
hexa={0:"0",
      1:"1",
      2:"2",
      3:"3",
      4:"4",
      5:"5",
      6:"6",
      7:"7",
      8:"8",
      9:"9",
      10:"A",
      11:"B",
      12:"C",
      13:"D",
      14:"E",
      15:"F"}

def couleur(j):
    i=255-int(255*j/nbpt)
    k=int(i/16)
    t=hexa[k]
    k=int(i-16*k)
    t+=hexa[k]
    t+=t+t
    print(t)
    return(t)
        



# calcul des coordonnées y[i] fractales
trace(delta)

print(y)
min=y[0][0]
max=y[0][0]
for j in range(0,nbpt):
    for i in range(0,nbpt):
        if min>y[i][j]:
            min=y[i][j]
        if max<y[i][j]:
            max=y[i][j]
                
offset=int((max-min)/2)



#création du fichier SVG
#exemple SVG:
#<svg xmlns="http://www.w3.org/2000/svg" width="100%" height="100%">
#  <polygon points="20,20 100,20 100,100 30,110"/>
#  <path        d="M20,20 100,20 100,100 30,110z" fill="green" transform="translate(100,0)"/>
#</svg>



largeur=nbpt+1 #defini la taille du SVG
hauteur =int(max-min+2+offset)
min=int(min+1)
entete="<svg xmlns=\"http://www.w3.org/2000/svg\" width=\"100%\" height=\"100%\">\n"
pied="</svg>\n"
styla="\n   <path  id=\"path2985\" style=\"fill:#"
stylb=";fill-opacity:1;stroke:#000000;stroke-width:1px;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1\" /> \n"

modelepolygone="<polygon points=\"20,70 80,70 60,55 55,60 40,55\"/>"
 
texte=entete


for j in range(0,nbpt):
    texte+="<path d=\"M"
    texte+=str(nbpt-1)+","+str(int(offset+max-min+offy*j))+" " #int(offset+max)
    texte+="0,"+str(int(offset+max-min+offy*j))+" "
    for i in range(0,nbpt):
        texte+=str(i)+","+str(y[i][j]-min+offy*j)+" "
    texte+="\" fill=\"#"+couleur(j)+"\" transform=\"translate(0,0)\"/>\n"
    
texte+=pied

f.write(texte)
f.close()
